package com.prank.sound.app.pageview;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.SystemClock;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;

import com.prank.sound.app.R;
import com.prank.sound.app.databinding.LayoutRecordAudioBinding;
import com.prank.sound.app.myutils.Recorder;
import com.prank.sound.app.myutils.Utils;
import com.prank.sound.app.topon.AdManager;
import com.prank.sound.app.topon.onActionListener;

public class RecordSoundsActivity extends AppCompatActivity {
    LayoutRecordAudioBinding binding;
    private long startTime;
    private long elapsedTime;
    private Handler handler = new Handler();
    private Runnable runnable;
    private boolean isCreate = false;

    private Recorder recorder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = LayoutRecordAudioBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        Utils.setStatusBarTextColor(this, true);
        recorder = new Recorder(this);
        AdManager.loadAllAd();
        binding.audioTime.setText(R.string.time_init);
        AdManager.showTopOn(this, new onActionListener() {
            @Override
            public void onAction() {

            }
        });

        initEvent();
    }

    private void initEvent() {
        binding.back.setOnClickListener(v -> finish());
        binding.imMic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                binding.imMic.setSelected(!binding.imMic.isSelected());
                createSound();
            }
        });
    }

    private void createSound() {
        if (!isCreate) {
            recorder.startRecording();
            isCreate = true;
            runnable = new Runnable() {
                @SuppressLint("DefaultLocale")
                @Override
                public void run() {
                    long currentTime = SystemClock.elapsedRealtime();
                    elapsedTime = currentTime - startTime;
                    int milliseconds = (int) (elapsedTime % 1000) / 10;
                    int seconds = (int) (elapsedTime / 1000) % 60;
                    int minutes = (int) (elapsedTime / (1000 * 60)) % 60;
                    binding.audioTime.setText(String.format("%02d : %02d : %02d", minutes, seconds, milliseconds));
                    handler.postDelayed(this, 10);
                }
            };
            startTime = SystemClock.elapsedRealtime();
            handler.post(runnable);
        } else {
            recorder.stopRecording();

            handler.removeCallbacks(runnable);
            Intent intent = new Intent(RecordSoundsActivity.this, StoreSoundsActivity.class);
            intent.putExtra(StoreSoundsActivity.KEY_Time, elapsedTime);
            intent.putExtra(StoreSoundsActivity.KEY_Path, recorder.getTempFileName());
            intent.putExtra(StoreSoundsActivity.KEY_import, 1);
            startActivity(intent);
            finish();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        handler.removeCallbacks(runnable);
    }
}